import {SpeakingExercise} from "@/interfaces/exam";
import {CommonProps} from ".";
import {Fragment, useEffect, useState} from "react";
import {BsCheckCircleFill, BsMicFill, BsPauseCircle, BsPlayCircle, BsTrashFill} from "react-icons/bs";
import dynamic from "next/dynamic";
import Button from "../Low/Button";
import useExamStore from "@/stores/examStore";

const Waveform = dynamic(() => import("../Waveform"), {ssr: false});
const ReactMediaRecorder = dynamic(() => import("react-media-recorder").then((mod) => mod.ReactMediaRecorder), {
	ssr: false,
});

export default function Speaking({id, title, text, video_url, type, prompts, onNext, onBack}: SpeakingExercise & CommonProps) {
	const [recordingDuration, setRecordingDuration] = useState(0);
	const [isRecording, setIsRecording] = useState(false);
	const [mediaBlob, setMediaBlob] = useState<string>();

	const hasExamEnded = useExamStore((state) => state.hasExamEnded);

	useEffect(() => {
		if (hasExamEnded) {
			onNext({
				exercise: id,
				solutions: mediaBlob ? [{id, solution: mediaBlob}] : [],
				score: {correct: 1, total: 1, missing: 0},
				type,
			});
		}
		// eslint-disable-next-line react-hooks/exhaustive-deps
	}, [hasExamEnded]);

	useEffect(() => {
		let recordingInterval: NodeJS.Timer | undefined = undefined;
		if (isRecording) {
			recordingInterval = setInterval(() => setRecordingDuration((prev) => prev + 1), 1000);
		} else if (recordingInterval) {
			clearInterval(recordingInterval);
		}

		return () => {
			if (recordingInterval) clearInterval(recordingInterval);
		};
	}, [isRecording]);

	return (
		<div className="flex flex-col h-full w-full gap-9">
			<div className="flex flex-col w-full gap-2 bg-mti-gray-smoke rounded-xl py-8 px-16">
				<div className="flex flex-col gap-3">
					<span className="font-semibold">{title}</span>
					{!video_url && (
						<span className="font-regular">
							{text.split("\\n").map((line, index) => (
								<Fragment key={index}>
									<span>{line}</span>
									<br />
								</Fragment>
							))}
						</span>
					)}
				</div>
				<div className="flex gap-6">
					{video_url && (
						<div className="flex flex-col gap-4 w-full items-center">
							<video key={id} autoPlay controls className="max-w-3xl rounded-xl">
								<source src={video_url} />
							</video>
						</div>
					)}
					{prompts && prompts.length > 0 && (
						<div className="flex flex-col gap-4">
							<span className="font-bold">You should talk about the following things:</span>
							<div className="flex flex-col gap-1 ml-4">
								{prompts.map((x, index) => (
									<li className="italic" key={index}>
										{x}
									</li>
								))}
							</div>
						</div>
					)}
				</div>
			</div>

			<ReactMediaRecorder
				audio
				onStop={(blob) => setMediaBlob(blob)}
				render={({status, startRecording, stopRecording, pauseRecording, resumeRecording, clearBlobUrl, mediaBlobUrl}) => (
					<div className="w-full p-4 px-8 bg-transparent border-2 border-mti-gray-platinum rounded-2xl flex-col gap-8 items-center">
						<p className="text-base font-normal">Record your answer:</p>
						<div className="flex gap-8 items-center justify-center py-8">
							{status === "idle" && (
								<>
									<div className="w-full h-2 max-w-4xl bg-mti-gray-smoke rounded-full" />
									{status === "idle" && (
										<BsMicFill
											onClick={() => {
												setRecordingDuration(0);
												startRecording();
												setIsRecording(true);
											}}
											className="h-5 w-5 text-mti-gray-cool cursor-pointer"
										/>
									)}
								</>
							)}
							{status === "recording" && (
								<>
									<div className="flex gap-4 items-center">
										<span className="text-xs w-9">
											{Math.floor(recordingDuration / 60)
												.toString(10)
												.padStart(2, "0")}
											:
											{Math.floor(recordingDuration % 60)
												.toString(10)
												.padStart(2, "0")}
										</span>
									</div>
									<div className="w-full h-2 max-w-4xl bg-mti-gray-smoke rounded-full" />
									<div className="flex gap-4 items-center">
										<BsPauseCircle
											onClick={() => {
												setIsRecording(false);
												pauseRecording();
											}}
											className="text-red-500 w-8 h-8 cursor-pointer"
										/>
										<BsCheckCircleFill
											onClick={() => {
												setIsRecording(false);
												stopRecording();
											}}
											className="text-mti-purple-light w-8 h-8 cursor-pointer"
										/>
									</div>
								</>
							)}
							{status === "paused" && (
								<>
									<div className="flex gap-4 items-center">
										<span className="text-xs w-9">
											{Math.floor(recordingDuration / 60)
												.toString(10)
												.padStart(2, "0")}
											:
											{Math.floor(recordingDuration % 60)
												.toString(10)
												.padStart(2, "0")}
										</span>
									</div>
									<div className="w-full h-2 max-w-4xl bg-mti-gray-smoke rounded-full" />
									<div className="flex gap-4 items-center">
										<BsPlayCircle
											onClick={() => {
												setIsRecording(true);
												resumeRecording();
											}}
											className="text-mti-purple-light w-8 h-8 cursor-pointer"
										/>
										<BsCheckCircleFill
											onClick={() => {
												setIsRecording(false);
												stopRecording();
											}}
											className="text-mti-purple-light w-8 h-8 cursor-pointer"
										/>
									</div>
								</>
							)}
							{status === "stopped" && mediaBlobUrl && (
								<>
									<Waveform audio={mediaBlobUrl} waveColor="#FCDDEC" progressColor="#EF5DA8" />
									<div className="flex gap-4 items-center">
										<BsTrashFill
											className="text-mti-gray-cool cursor-pointer w-5 h-5"
											onClick={() => {
												setRecordingDuration(0);
												clearBlobUrl();
												setMediaBlob(undefined);
											}}
										/>

										<BsMicFill
											onClick={() => {
												clearBlobUrl();
												setRecordingDuration(0);
												startRecording();
												setIsRecording(true);
												setMediaBlob(undefined);
											}}
											className="h-5 w-5 text-mti-gray-cool cursor-pointer"
										/>
									</div>
								</>
							)}
						</div>
					</div>
				)}
			/>

			<div className="self-end flex justify-between w-full  gap-8">
				<Button
					color="purple"
					variant="outline"
					onClick={() =>
						onBack({
							exercise: id,
							solutions: mediaBlob ? [{id, solution: mediaBlob}] : [],
							score: {correct: 1, total: 1, missing: 0},
							type,
						})
					}
					className="max-w-[200px] self-end w-full">
					Back
				</Button>
				<Button
					color="purple"
					disabled={!mediaBlob}
					onClick={() =>
						onNext({
							exercise: id,
							solutions: mediaBlob ? [{id, solution: mediaBlob}] : [],
							score: {correct: 1, total: 1, missing: 0},
							type,
						})
					}
					className="max-w-[200px] self-end w-full">
					Next
				</Button>
			</div>
		</div>
	);
}
